<?php

namespace STM\Import\Parser;

use \Exception;

/**
 * Test class for ImportParser.
 * Generated by PHPUnit on 2012-08-26 at 11:14:46.
 * @group import
 */
class ImportParserTest extends \PHPUnit_Framework_TestCase {

    /** @var ImportParser */
    private $parser;

    protected function setUp() {
        $this->createParserWithFormat('{TEAM};{P}');
    }

    public function testParseCompleteString() {
        parent::assertEquals(
                array('team' => 'Makov', 'players' => array('Zdenek Drahos')),
                $this->parser->parseString('Makov;Zdenek Drahos')
        );
    }

    public function testParseIncompleteString() {        
        parent::assertEquals(
                array('team' => 'Makov'),
                $this->parser->parseString('Makov;')
        );
        parent::assertEquals(
                array('team' => 'Makov'),
                $this->parser->parseString('Makov')
        );
    }

    public function testParseRepeatingKeysInFormat() {
        $this->createParserWithFormat('{TEAM};{P},{P};{TEAM}');        
        parent::assertEquals(
                array(
                    'team' => 'Makov u Litomyšle', 
                    'players' => array('Zdenek Drahos', 'Drahos Zdenek')
                ),
                $this->parser->parseString('Makov;Zdenek Drahos,Drahos Zdenek; u Litomyšle')
        );
        parent::assertEquals(array('team' => 'Makov'), $this->parser->parseString('Makov;,;'));
        parent::assertEquals(array('team' => 'Makov'), $this->parser->parseString('Makov'));
    }

    public function testParseStringWithWeirdFormat() {
        $this->createParserWithFormat('{TEAM};;;');      
        parent::assertEquals(
                array('team' => 'Makov'),
                $this->parser->parseString('Makov')
        );
    }

    public function testParseInvalidValue() {
        parent::assertEquals(array(), $this->parser->parseString(new Exception()));
    }

    private function createParserWithFormat($format) {
        $importFormat = new ImportFormat();
        $importFormat->setFormat($format);
        $importFormat->addKey(new ImportKey('TEAM', 'team', ImportValueType::STRING));
        $importFormat->addKey(new ImportKey('P', 'players', ImportValueType::ARRAYS));
        $this->parser = new ImportParser($importFormat);
    }

}

?>
